%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 7;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}

%bcond_without check

%global crate bat

Name:           rust-bat
Version:        0.24.0
Release:    1%{?dist}
Summary:        Cat(1) clone with wings

License:        (MIT OR Apache-2.0) AND Apache-2.0 AND BSD-2-Clause AND BSD-2-Clause-Views AND BSD-3-Clause AND CC-BY-SA-3.0 AND MIT AND Unlicense AND WTFPL AND LicenseRef-Fedora-UltraPermissive
URL:            https://crates.io/crates/bat
Source0:         %{crates_source}
Patch:          bat-fix-metadata-auto.diff
Patch:          bat-fix-metadata.diff
Patch:          0001-port-from-path_abs-to-path-absolutize.patch

BuildRequires:  cargo-rpm-macros >= 24

%global _description %{expand:
A cat(1) clone with wings.}

%global _bundled_deps %{expand:
Provides:       bundled(sublime-syntax) = 4075~git759d6ee

Provides:       bundled(sublime-syntax-AWK)
Provides:       bundled(sublime-syntax-Ada)
Provides:       bundled(sublime-syntax-Apache)
Provides:       bundled(sublime-syntax-AsciiDoc)
Provides:       bundled(sublime-syntax-CMake)
Provides:       bundled(sublime-syntax-CoffeeScript)
Provides:       bundled(sublime-syntax-Crontab)
Provides:       bundled(sublime-syntax-Crontab-cron_descriptor)
Provides:       bundled(sublime-syntax-Crystal)
Provides:       bundled(sublime-syntax-Dart)
Provides:       bundled(sublime-syntax-Docker)
Provides:       bundled(sublime-syntax-DotENV)
Provides:       bundled(sublime-syntax-Elixir)
Provides:       bundled(sublime-syntax-Elm)
Provides:       bundled(sublime-syntax-Email)
Provides:       bundled(sublime-syntax-Fish)
Provides:       bundled(sublime-syntax-GLSL)
Provides:       bundled(sublime-syntax-GraphQL)
Provides:       bundled(sublime-syntax-Groff)
Provides:       bundled(sublime-syntax-HTML-Twig)
Provides:       bundled(sublime-syntax-JavaScript-Babel)
Provides:       bundled(sublime-syntax-Jsonnet)
Provides:       bundled(sublime-syntax-Julia)
Provides:       bundled(sublime-syntax-Kotlin)
Provides:       bundled(sublime-syntax-LLVM)
Provides:       bundled(sublime-syntax-Lean)
Provides:       bundled(sublime-syntax-LiveScript)
Provides:       bundled(sublime-syntax-MediaWiki)
Provides:       bundled(sublime-syntax-NSIS)
Provides:       bundled(sublime-syntax-Nginx)
Provides:       bundled(sublime-syntax-Ninja)
Provides:       bundled(sublime-syntax-Nix)
Provides:       bundled(sublime-syntax-Org-mode)
Provides:       bundled(sublime-syntax-PowerShell)
Provides:       bundled(sublime-syntax-Protobuf)
Provides:       bundled(sublime-syntax-Puppet)
Provides:       bundled(sublime-syntax-PureScript)
Provides:       bundled(sublime-syntax-QML)
Provides:       bundled(sublime-syntax-Robot)
Provides:       bundled(sublime-syntax-SCSS_Sass)
Provides:       bundled(sublime-syntax-SLS)
Provides:       bundled(sublime-syntax-Slim)
Provides:       bundled(sublime-syntax-Stylus)
Provides:       bundled(sublime-syntax-SublimeEthereum)
Provides:       bundled(sublime-syntax-Svelte)
Provides:       bundled(sublime-syntax-Swift)
Provides:       bundled(sublime-syntax-SystemVerilog)
Provides:       bundled(sublime-syntax-TOML)
Provides:       bundled(sublime-syntax-Terraform)
Provides:       bundled(sublime-syntax-TypeScript)
Provides:       bundled(sublime-syntax-VimL)
Provides:       bundled(sublime-syntax-Vue)
Provides:       bundled(sublime-syntax-Zig)
Provides:       bundled(sublime-syntax-cmd-help)
Provides:       bundled(sublime-syntax-gnuplot)
Provides:       bundled(sublime-syntax-hosts)
Provides:       bundled(sublime-syntax-http-request-response)
Provides:       bundled(sublime-syntax-varlink)
Provides:       bundled(sublime-syntax-vscode-wgsl)

Provides:       bundled(sublime-theme-1337-Scheme)
Provides:       bundled(sublime-theme-Coldark)
Provides:       bundled(sublime-theme-DarkNeon)
Provides:       bundled(sublime-theme-Nord-sublime)
Provides:       bundled(sublime-theme-Solarized)
Provides:       bundled(sublime-theme-TwoDark)
Provides:       bundled(sublime-theme-dracula-sublime)
Provides:       bundled(sublime-theme-github-sublime-theme)
Provides:       bundled(sublime-theme-gruvbox)
Provides:       bundled(sublime-theme-onehalf)
Provides:       bundled(sublime-theme-sublime-monokai-extended)
Provides:       bundled(sublime-theme-sublime-snazzy)
Provides:       bundled(sublime-theme-visual-studio-dark-plus)
Provides:       bundled(sublime-theme-zenburn)
}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}

%{_bundled_deps}

License:        Apache-2.0 AND BSD-2-Clause AND BSD-2-Clause-Views AND BSD-3-Clause AND CC-BY-SA-3.0 AND LGPL-3.0-or-later AND GPL-2.0-only WITH GCC-exception-2.0 AND MIT AND Unicode-DFS-2016 AND Unlicense AND WTFPL AND (0BSD OR MIT OR Apache-2.0) AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND (MIT OR Apache-2.0 OR Zlib) AND (Unlicense OR MIT)

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE-APACHE
%license LICENSE-MIT
%license NOTICE
%license LICENSE.dependencies
%doc CHANGELOG.md
%doc CONTRIBUTING.md
%doc README.md
%{_bindir}/bat
%{_mandir}/man1/bat.1*
%{bash_completions_dir}/bat.bash
%{fish_completions_dir}/bat.fish
%{zsh_completions_dir}/_bat

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%{_bundled_deps}

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE-APACHE
%license %{crate_instdir}/LICENSE-MIT
%license %{crate_instdir}/NOTICE
%doc %{crate_instdir}/CHANGELOG.md
%doc %{crate_instdir}/CONTRIBUTING.md
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+application-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+application-devel %{_description}

This package contains library source intended for building other packages which
use the "application" feature of the "%{crate}" crate.

%files       -n %{name}+application-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+bugreport-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+bugreport-devel %{_description}

This package contains library source intended for building other packages which
use the "bugreport" feature of the "%{crate}" crate.

%files       -n %{name}+bugreport-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+build-assets-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+build-assets-devel %{_description}

This package contains library source intended for building other packages which
use the "build-assets" feature of the "%{crate}" crate.

%files       -n %{name}+build-assets-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+clap-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+clap-devel %{_description}

This package contains library source intended for building other packages which
use the "clap" feature of the "%{crate}" crate.

%files       -n %{name}+clap-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+etcetera-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+etcetera-devel %{_description}

This package contains library source intended for building other packages which
use the "etcetera" feature of the "%{crate}" crate.

%files       -n %{name}+etcetera-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+git-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+git-devel %{_description}

This package contains library source intended for building other packages which
use the "git" feature of the "%{crate}" crate.

%files       -n %{name}+git-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+git2-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+git2-devel %{_description}

This package contains library source intended for building other packages which
use the "git2" feature of the "%{crate}" crate.

%files       -n %{name}+git2-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+grep-cli-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+grep-cli-devel %{_description}

This package contains library source intended for building other packages which
use the "grep-cli" feature of the "%{crate}" crate.

%files       -n %{name}+grep-cli-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+lessopen-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+lessopen-devel %{_description}

This package contains library source intended for building other packages which
use the "lessopen" feature of the "%{crate}" crate.

%files       -n %{name}+lessopen-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+minimal-application-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+minimal-application-devel %{_description}

This package contains library source intended for building other packages which
use the "minimal-application" feature of the "%{crate}" crate.

%files       -n %{name}+minimal-application-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+os_str_bytes-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+os_str_bytes-devel %{_description}

This package contains library source intended for building other packages which
use the "os_str_bytes" feature of the "%{crate}" crate.

%files       -n %{name}+os_str_bytes-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+paging-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+paging-devel %{_description}

This package contains library source intended for building other packages which
use the "paging" feature of the "%{crate}" crate.

%files       -n %{name}+paging-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+regex-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+regex-devel %{_description}

This package contains library source intended for building other packages which
use the "regex" feature of the "%{crate}" crate.

%files       -n %{name}+regex-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+regex-fancy-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+regex-fancy-devel %{_description}

This package contains library source intended for building other packages which
use the "regex-fancy" feature of the "%{crate}" crate.

%files       -n %{name}+regex-fancy-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+regex-onig-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+regex-onig-devel %{_description}

This package contains library source intended for building other packages which
use the "regex-onig" feature of the "%{crate}" crate.

%files       -n %{name}+regex-onig-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+run_script-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+run_script-devel %{_description}

This package contains library source intended for building other packages which
use the "run_script" feature of the "%{crate}" crate.

%files       -n %{name}+run_script-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+shell-words-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+shell-words-devel %{_description}

This package contains library source intended for building other packages which
use the "shell-words" feature of the "%{crate}" crate.

%files       -n %{name}+shell-words-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+walkdir-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+walkdir-devel %{_description}

This package contains library source intended for building other packages which
use the "walkdir" feature of the "%{crate}" crate.

%files       -n %{name}+walkdir-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+wild-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+wild-devel %{_description}

This package contains library source intended for building other packages which
use the "wild" feature of the "%{crate}" crate.

%files       -n %{name}+wild-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
%cargo_install
install -Dpm0644 target/release/build/%{crate}-*/out/assets/manual/bat.1 \
    -t %{buildroot}%{_mandir}/man1/
install -Dpm0644 target/release/build/%{crate}-*/out/assets/completions/bat.bash \
    %{buildroot}/%{bash_completions_dir}/bat.bash
install -Dpm0644 target/release/build/%{crate}-*/out/assets/completions/bat.fish \
    %{buildroot}/%{fish_completions_dir}/bat.fish
install -Dpm0644 target/release/build/%{crate}-*/out/assets/completions/bat.zsh \
    %{buildroot}/%{zsh_completions_dir}/_bat

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Tue Jun 18 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.24.0-1
- initial build
